HDOJ7059Counting Stars(线段树,区间加,乘,标记)

Posted 小哈里

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了HDOJ7059Counting Stars(线段树,区间加,乘,标记)相关的知识,希望对你有一定的参考价值。

1004 Counting Stars

题意:

  • 给出一个长为n的序列(1e5),支持3种操作:
    1:查询[l,r]的区间和
    2:修改[l,r]中每个数,都减去lowbit(x)
    3:修改[l,r]中每个数,都加上2^k, 2^k<=ai

思路:

  • 对于操作2,减去lowbit(x)相当于去掉最后一位的1。可以发现,不断删1后,一个数最多删32次就会变为0,此后修改查询都是0。所以我们可以打个tag表示该区间是否所有数为0,用标记下传维护,剩余的情况暴力修改。
  • 对于操作3,加上2^k相当于第一位1左移一位。可以发现,该操作仅与最高位有关,与后面的位无关。所以我们可以把最高位单独维护,操作3相当于整个区间乘2,线段树维护区间乘法即可。
#include<bits/stdc++.h>
using namespace std;
typedef long long LL;
const int maxn = 1e5+10;
const LL mod = 998244353;

LL a1[maxn], a2[maxn];
LL lowbit(LL x){ return x&(-x);}

//线段树:s1维护最高位, s2维护剩余位,tg1表示区间乘2,tg2表示区间全为0。
LL s1[maxn<<2], s2[maxn<<2], tg1[maxn<<2], tg2[maxn<<2];
#define lch p<<1
#define rch p<<1|1
void pushup(int p){   //更新完pushup
	s1[p] = (s1[lch]+s1[rch])%mod;	//维护区间和
	s2[p] = (s2[lch]+s2[rch])%mod;  //维护区间和
	tg2[p] = tg2[lch]&tg2[rch];		//左右子树都全为0了才为0
}
void pushdown(int p){ //查询前pushdown
	tg1[lch] = tg1[lch]*tg1[p]%mod;
	tg1[rch] = tg1[rch]*tg1[p]%mod;
	s1[lch] = s1[lch]*tg1[p]%mod;
	s1[rch] = s1[rch]*tg1[p]%mod;
	tg1[p] = 1;
	tg2[lch] |= tg2[p];
	tg2[rch] |= tg2[p];
	if(tg2[lch])s2[lch] = 0;
	if(tg2[rch])s2[rch] = 0;
}
void build(int p, int l, int r){
	tg1[p] = 1, tg2[p] = 0;		 //区间乘标记1,全为0标记0。
	if(l == r){
		s1[p] = a1[l], s2[p] = a2[l];
		return ;
	}
	int mid = l+r>>1;
	build(lch, l, mid);
	build(rch, mid+1, r);
	pushup(p);
}
LL query(int p, int l, int r, int ll, int rr){//return sum{s1+s2}[ll,rr];
	if(ll>r || rr<l)return 0;
	if(ll<=l && r<=rr){
		return (s1[p]+s2[p])%mod;
	}
	pushdown(p);
	int mid = l+r>>1;
	LL ans = 0;
	ans += query(lch, l, mid, ll, rr);
	ans += query(rch, mid+1, r, ll, rr);
	ans %=mod;
	return ans;
}
void update1(int p, int l, int r, int ll, int rr){//s2[ll,rr]-=lowbit;(暴力)
	if(ll>r || rr<l)return ;//区间在范围外
	if(tg2[p])return ;		//区间全为0,再见
	if(l==r){				//到叶节点才能单点暴力修改
		if(s2[p]!=0){ s2[p]-=lowbit(s2[p]);}//去掉一个lowbit
		else {s1[p]=0; tg2[p]=1;}//除了最高位已经都是0了,那最高位没了
		return ;
	}
	pushdown(p);
	int mid = l+r>>1;
	update1(lch, l, mid, ll, rr);
	update1(rch, mid+1, r, ll, rr);
	pushup(p);
}
void update2(int p, int l, int r, int ll, int rr){//s1[ll,rr] *= 2;(Lazy)
	if(ll>r || rr<l)return ;   //区间完全在范围外
	if(ll<=l && r<=rr){		   //区间完全被包含
		s1[p] = s1[p]*2%mod;   //sum[l,r] *= 2;
		tg1[p] = tg1[p]*2%mod; //lazy tag, then return ;
		return ;
	}
	pushdown(p);
	int mid = l+r>>1;
	update2(lch, l, mid, ll, rr);
	update2(rch, mid+1, r, ll, rr);
	pushup(p);
}

int main(){
	ios::sync_with_stdio(0),cin.tie(0),cout.tie(0);
	int T;  cin>>T;
	while(T--){
		int n;  cin>>n;
		for(int i = 1; i <= n; i++){
			LL x;  cin>>x;
			for(int k=30; k>=0; k--){
				if((1ll<<k)<=x){	//找到最高位
					a1[i] = 1ll<<k; //提取最高位
					a2[i] = x-a1[i];//存剩余的数
					break; 
				}
			}
		}
		build(1,1,n);
		int q;  cin>>q;
		for(int i = 1; i <= q; i++){
			int op, l, r;  cin>>op>>l>>r;
			if(op==1)cout<<query(1,1,n,l,r)<<"\\n";
			else if(op==2)update1(1,1,n,l,r);
			else update2(1,1,n,l,r);
		}
	}
	return 0;
}

以上是关于HDOJ7059Counting Stars(线段树,区间加,乘,标记)的主要内容,如果未能解决你的问题,请参考以下文章

HDU7059-Counting Stars 线段树 (区间加最低位置,区间减最高位)

HDU7059-Counting Stars 线段树 (区间加最低位置,区间减最高位)

D - Counting Stars HDU - 7059

HDU 6184 Counting Stars

HDU 6184 Counting Stars

@hdu - 6184@ Counting Stars